extern int CCI_period = 170;
extern double Treshold = 30.0;
extern int MaxOrders = 1;
extern double Lot = 0.1;
extern double MaximumRisk=0;
extern int TP = 00;
extern int SL = 00;
extern int TrailingStop = 20;

int MagicNumber = 07092009;
int ticket;
double orderTP, orderSL;
string AN;


int start()
  {
  TrailOrders();
  if (Volume[0]>1) return;
  double cci_1 = iCCI(NULL,0,CCI_period,PRICE_CLOSE,1);
  double cci_2 = iCCI(NULL,0,CCI_period,PRICE_CLOSE,2);
  
  bool BUY_Open = cci_2<Treshold && cci_1>Treshold;
  bool SELL_Open = cci_2>-Treshold && cci_1<-Treshold;
  
  bool BUY_Close =  SELL_Open;
  bool SELL_Close = BUY_Open;
  
  if (SELL_Close)   {
   Order_close(OP_SELL);
   }
   if (BUY_Close)   {
      Order_close(OP_BUY);
   }
   
   if (MaximumRisk>0.0) {
   Lot = NormalizeDouble(MathCeil(MaximumRisk * AccountEquity() / 10000.0) / 10.0, 2);
   double minlot = MarketInfo(Symbol(), MODE_MINLOT);
   double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   if (Lot < minlot) Lot = minlot;
   if (Lot > maxlot) Lot = maxlot;
}
   
if (SELL_Open)   {
   if (TP>0) orderTP = Bid-TP*Point; else orderTP = 0;
   if (SL>0) orderSL = Ask+SL*Point; else orderSL = 0;
   if (OrdersTotal() < MaxOrders) {
      OrderSend(Symbol(),OP_SELL,Lot,Bid,3,orderSL,orderTP,"My order #",MagicNumber,0,Red);
      //AN="ArrSell "+TimeToStr(CurTime());
      //ObjectCreate(AN,OBJ_ARROW,0,Time[0],High[0]+6*Point,0,0,0,0);
      //ObjectSet(AN, OBJPROP_ARROWCODE, 234);
      //ObjectSet(AN, OBJPROP_COLOR , Red);
   }
}
if (BUY_Open)   {
   if (TP>0) orderTP = Ask+TP*Point; else orderTP = 0;
   if (SL>0) orderSL = Bid-SL*Point; else orderSL = 0;
   if (OrdersTotal() < MaxOrders) {
      OrderSend(Symbol(),OP_BUY,Lot,Ask,3,orderSL,orderTP,"My order #",MagicNumber,0,Green);
      //AN="ArrBuy "+TimeToStr(CurTime());
      //ObjectCreate(AN,OBJ_ARROW,0,Time[0],Low[0]-6*Point,0,0,0,0);
      //ObjectSet(AN, OBJPROP_ARROWCODE, 241);
      //ObjectSet(AN, OBJPROP_COLOR , Green);
    }
}
  
   return(0);
  }
  
int Order_close(int type) {
bool closeOK = false;
   RefreshRates();
   for (int i=OrdersTotal();i>=0;i--) {
      OrderSelect(i,SELECT_BY_POS);
      if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()) {
         ticket = OrderTicket();
         if (type == OP_BUY && OrderType() == OP_BUY) {
         Print("OrderClose buy: type=",type,OrderType());
            closeOK=OrderClose(ticket,OrderLots(),Bid,3,Red);
            Print("OrderClose: BUY order close status: ",closeOK," ",GetLastError());
         }
         if (type == OP_SELL  && OrderType() == OP_SELL) {
         Print("OrderClose sell: type=",type,OrderType());
           closeOK= OrderClose(ticket,OrderLots(),Ask,3,Red);
           Print("OrderClose: SELL order close status: ",closeOK," ",GetLastError());
         }
      }   
   }
}

void TrailOrders()
{
   if(TrailingStop>0)
   {
      for (int i=OrdersTotal();i>=0;i--) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()) {
         if(OrderType()==OP_BUY)      
            if(Bid-OrderOpenPrice()>Point*TrailingStop)
               if(OrderStopLoss()<Bid-Point*TrailingStop)
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);

         if(OrderType()==OP_SELL)
            if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
               if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
      }
      }
   }
}